#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <jpeglib.h>

/****************** for gettime:begin **************************/
//#include <stdio.h>
//#include <sys/time.h>
/****************** for gettime:end **************************/

#define FB_WIDTH	800
#define FB_HEIGHT 	480
#define PIX_SIZE 	4 // ARGB8888

int main() {
	struct jpeg_compress_struct cinfo;
	struct jpeg_error_mgr jerr;
	FILE *outfile;
	FILE *infile;

	JSAMPARRAY img;
    	int i, j;

	unsigned char *img_buf;

/****************** for gettime:begin **************************/
//    	struct timeval time;
//
//    	gettimeofday(&time, NULL);
//	printf("sec:%d, usec:%d\n", time.tv_sec, time.tv_usec);
/****************** for gettime:end **************************/

/*
	img = (JSAMPARRAY)malloc(sizeof(JSAMPROW) * FB_HEIGHT);
	for(i = 0; i < FB_HEIGHT; i++) {
		img[i] = (JSAMPROW)malloc(sizeof(JSAMPLE) * 3 * FB_WIDTH);
		for(j = 0; j < FB_WIDTH; j++) {
			img[i][j * 3 + 0] = i;
			img[i][j * 3 + 1] = 0;
            		img[i][j * 3 + 2] = j;
        	}
    	}
*/

	img_buf = (unsigned char*)malloc(FB_WIDTH *FB_HEIGHT * 4);

//	system("cat /dev/fb1 > /root/fb1file");
//	infile = fopen("/root/fb1file", "rb");

	system("mkdir -p /var/tmp/for_lcd2jpeg/fb_file");
	system("mkdir -p /var/tmp/for_lcd2jpeg/jpeg_file");

	system("cat /dev/fb1 > /var/tmp/for_lcd2jpeg/fb_file/fb1file");
	infile = fopen("/var/tmp/for_lcd2jpeg/fb_file/fb1file", "rb");
	fread(img_buf, PIX_SIZE, FB_WIDTH * FB_HEIGHT, infile);
	fclose(infile);

	img = (JSAMPARRAY)malloc(sizeof(JSAMPROW) * FB_HEIGHT);
	for(i = 0; i < FB_HEIGHT; i++) {
		img[i] = (JSAMPROW)malloc(sizeof(JSAMPLE) * 3 * FB_WIDTH);
		for(j = 0; j < FB_WIDTH; j++) {
            		img[i][j * 3 + 2] = *(img_buf + (i * FB_WIDTH * 4 + j * 4 + 0)) ;
            		img[i][j * 3 + 1] = *(img_buf + (i * FB_WIDTH * 4 + j * 4 + 1)) ;
            		img[i][j * 3 + 0] = *(img_buf + (i * FB_WIDTH * 4 + j * 4 + 2)) ;
        	}
    	}

	free(img_buf);

    	cinfo.err = jpeg_std_error(&jerr);
    	jpeg_create_compress(&cinfo);

//    	outfile = fopen("/home/www-data/lcd.jpg", "wb");
    	outfile = fopen("/var/tmp/for_lcd2jpeg/jpeg_file/lcd.jpg", "wb");
    	jpeg_stdio_dest(&cinfo, outfile);

    	cinfo.image_width = FB_WIDTH;
    	cinfo.image_height = FB_HEIGHT;
    	cinfo.input_components = 3;
    	cinfo.in_color_space = JCS_RGB;

    	jpeg_set_defaults(&cinfo);
    	jpeg_set_quality(&cinfo, 75, TRUE);

    	jpeg_start_compress(&cinfo, TRUE);
    	jpeg_write_scanlines(&cinfo, img, FB_HEIGHT);
    	jpeg_finish_compress(&cinfo);
    	jpeg_destroy_compress(&cinfo);

    	fclose(outfile);

    	for(i = 0; i < FB_HEIGHT; i++) {
        	free(img[i]);
    	}
    	free(img);
/****************** for gettime:begin **************************/
//    	gettimeofday(&time, NULL);
//	printf("sec:%d, usec:%d\n", time.tv_sec, time.tv_usec);
/****************** for gettime:end **************************/
}
